### Class

# Gio AppInfoMonitor

since: 2.40

#### Description

    final class Gio.AppInfoMonitor : GObject.Object
    {
      /* No available fields */
    }

`GAppInfoMonitor` monitors application information for changes.

`GAppInfoMonitor` is a very simple object used for monitoring the app info database for changes (newly installed or removed applications).

Call `g_app_info_monitor_get()` to get a `GAppInfoMonitor` and connect to the `GAppInfoMonitor::changed` signal. The signal will be emitted once when the app info database changes, and will not be emitted again until after the next call to `g_app_info_get_all()` or another `g_app_info_*()` function. This is because monitoring the app info database for changes is expensive.

The following functions will re-arm the `GAppInfoMonitor::changed` signal so it can be emitted again:

- `g_app_info_get_all()`
- `g_app_info_get_all_for_type()`
- `g_app_info_get_default_for_type()`
- `g_app_info_get_fallback_for_type()`
- `g_app_info_get_recommended_for_type()`
- `g_desktop_app_info_get_implementations()`
- `g_desktop_app_info_new()`
- `g_desktop_app_info_new_from_filename()`
- `g_desktop_app_info_new_from_keyfile()`
- `g_desktop_app_info_search()`

The latter functions are available if using `GDesktopAppInfo` from `gio-unix-2.0.pc` (GIR namespace `GioUnix-2.0`).

In the usual case, applications should try to make note of the change (doing things like invalidating caches) but not act on it. In particular, applications should avoid making calls to `GAppInfo` APIs in response to the change signal, deferring these until the time that the updated data is actually required. The exception to this case is when application information is actually being displayed on the screen (for example, during a search or when the list of all applications is shown). The reason for this is that changes to the list of installed applications often come in groups (like during system updates) and rescanning the list on every change is pointless and expensive.

Available since: 2.40

#### Ancestors

- GObject

#### Functions

###### g_app_info_monitor_get

Gets the `GAppInfoMonitor` for the current thread-default main context.

since: 2.40

#### Instance methods

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

#### Signals

###### Gio.AppInfoMonitor::changed

Signal emitted when the app info database changes, when applications are installed or removed.

since: 2.40

##### Signals inherited from GObject (1)

###### GObject::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.